std::__atomic_base< _PTp * > Struct Template Reference
Atomics

`#include <atomic_base.h>`

## Public Member Functions

constexpr | __atomic_base (__pointer_type __p) noexcept
| __atomic_base (const __atomic_base &)=delete
| __attribute__ ((__always_inline__)) void store(__pointer_type __p
bool | is_lock_free () const noexcept
bool | is_lock_free () const volatile noexcept
| operator __pointer_type () const noexcept
| operator __pointer_type () const volatile noexcept
__pointer_type | operator++ () noexcept
__pointer_type | operator++ () volatile noexcept
__pointer_type | operator++ (int) noexcept
__pointer_type | operator++ (int) volatile noexcept
__pointer_type | operator+= (ptrdiff_t __d) noexcept
__pointer_type | operator+= (ptrdiff_t __d) volatile noexcept
__pointer_type | operator-- () noexcept
__pointer_type | operator-- () volatile noexcept
__pointer_type | operator-- (int) noexcept
__pointer_type | operator-- (int) volatile noexcept
__pointer_type | operator-= (ptrdiff_t __d) noexcept
__pointer_type | operator-= (ptrdiff_t __d) volatile noexcept
__pointer_type | operator= (__pointer_type __p) noexcept
__pointer_type | operator= (__pointer_type __p) volatile noexcept
__atomic_base & | operator= (const __atomic_base &) volatile=delete
__atomic_base & | operator= (const __atomic_base &)=delete

## Detailed Description

template<typename _PTp>
struct std::__atomic_base< _PTp * >

Partial specialization for pointer types.

Definition at line 592 of file atomic_base.h.

## Constructor & Destructor Documentation

## __atomic_base()

template<typename _PTp >

constexpr std::__atomic_base< _PTp * >::__atomic_base | ( | __pointer_type | __p | ) |

inline constexpr noexcept

Definition at line 614 of file atomic_base.h.

## Member Function Documentation

## is_lock_free() [1/2]

template<typename _PTp >

bool std::__atomic_base< _PTp * >::is_lock_free | ( |  | ) | const

inline noexcept

Definition at line 693 of file atomic_base.h.

## is_lock_free() [2/2]

template<typename _PTp >

bool std::__atomic_base< _PTp * >::is_lock_free | ( |  | ) | const volatile

inline noexcept

Definition at line 701 of file atomic_base.h.

## operator __pointer_type() [1/2]

template<typename _PTp >

std::__atomic_base< _PTp * >::operator __pointer_type | ( |  | ) | const

inline noexcept

Definition at line 616 of file atomic_base.h.

## operator __pointer_type() [2/2]

template<typename _PTp >

std::__atomic_base< _PTp * >::operator __pointer_type | ( |  | ) | const volatile

inline noexcept

Definition at line 619 of file atomic_base.h.

## operator++() [1/4]

template<typename _PTp >

__pointer_type std::__atomic_base< _PTp * >::operator++ | ( |  | ) |

inline noexcept

Definition at line 653 of file atomic_base.h.

## operator++() [2/4]

template<typename _PTp >

__pointer_type std::__atomic_base< _PTp * >::operator++ | ( |  | ) | volatile

inline noexcept

Definition at line 658 of file atomic_base.h.

## operator++() [3/4]

template<typename _PTp >

__pointer_type std::__atomic_base< _PTp * >::operator++ | ( | int |  | ) |

inline noexcept

Definition at line 637 of file atomic_base.h.

## operator++() [4/4]

template<typename _PTp >

__pointer_type std::__atomic_base< _PTp * >::operator++ | ( | int |  | ) | volatile

inline noexcept

Definition at line 641 of file atomic_base.h.

## operator+=() [1/2]

template<typename _PTp >

__pointer_type std::__atomic_base< _PTp * >::operator+= | ( | ptrdiff_t | __d | ) |

inline noexcept

Definition at line 673 of file atomic_base.h.

## operator+=() [2/2]

template<typename _PTp >

__pointer_type std::__atomic_base< _PTp * >::operator+= | ( | ptrdiff_t | __d | ) | volatile

inline noexcept

Definition at line 678 of file atomic_base.h.

## operator--() [1/4]

template<typename _PTp >

__pointer_type std::__atomic_base< _PTp * >::operator-- | ( |  | ) |

inline noexcept

Definition at line 663 of file atomic_base.h.

## operator--() [2/4]

template<typename _PTp >

__pointer_type std::__atomic_base< _PTp * >::operator-- | ( |  | ) | volatile

inline noexcept

Definition at line 668 of file atomic_base.h.

## operator--() [3/4]

template<typename _PTp >

__pointer_type std::__atomic_base< _PTp * >::operator-- | ( | int |  | ) |

inline noexcept

Definition at line 645 of file atomic_base.h.

## operator--() [4/4]

template<typename _PTp >

__pointer_type std::__atomic_base< _PTp * >::operator-- | ( | int |  | ) | volatile

inline noexcept

Definition at line 649 of file atomic_base.h.

## operator-=() [1/2]

template<typename _PTp >

__pointer_type std::__atomic_base< _PTp * >::operator-= | ( | ptrdiff_t | __d | ) |

inline noexcept

Definition at line 683 of file atomic_base.h.

## operator-=() [2/2]

template<typename _PTp >

__pointer_type std::__atomic_base< _PTp * >::operator-= | ( | ptrdiff_t | __d | ) | volatile

inline noexcept

Definition at line 688 of file atomic_base.h.

## operator=() [1/2]

template<typename _PTp >

__pointer_type std::__atomic_base< _PTp * >::operator= | ( | __pointer_type | __p | ) |

inline noexcept

Definition at line 623 of file atomic_base.h.

## operator=() [2/2]

template<typename _PTp >

__pointer_type std::__atomic_base< _PTp * >::operator= | ( | __pointer_type | __p | ) | volatile

inline noexcept

Definition at line 630 of file atomic_base.h.

The documentation for this struct was generated from the following file:

- atomic_base.h